#ifndef __AUDIO_SOUND_H
#define __AUDIO_SOUND_H

#include "definitions.h"

class Audio_Sound
{
	public:
	Audio_Sound () ;
	
	Mix_Chunk *ConvertFromOgg ( char *filename ) ;
	
	void LoadSound ( char *filename ) ;

	void PlaySound ( int channel = -1, int times = 1 ) ;
	void StopSound () ;

	void FadeInSound ( int channel = -1, int times = 1, int ms = 2000 ) ;
	void FadeOutSound ( int ms = 2000 ) ;
	
	void SetVolume ( int value ) ;
	int GetVolume () ;
	
	// note that 0 is left, 128 is center and 256 is right!
	void SetPanning ( int pos ) ;
	int GetPanning () ;

	int IsPlaying () ;
	
	void UnloadSound () ;
	
	private:
	Mix_Chunk *SoundChunk ;
	int SoundChannel ;
	int panning_pos ;
	int volume ;
} ;

#endif
