#ifndef __CONSOLE_H
#define __CONSOLE_H

#include "definitions.h"

#ifdef __NETWORK_SUPPORT__

class Console
{
	public:
	void Init ( int new_x, int new_y,
				int new_width, int new_height, int new_linespacing,
				KrImNode *new_basenode, KrScheme new_scheme,
				bool has_command_line = true ) ;
	
	void ProcessEvents ( SDL_Event event ) ;
	
	void PushText ( std::string text ) ;
	
	std::string GetLine ( int line ) ;
	void SetLine ( int line, std::string text ) ;
	
	// returns numlines of the KrTextBox *cmdhistory widget! not the buffer!!!
	int NumLines () ;
	
	void Free () ;
	
	private:
	int x, y, width, height, spacing ;
	KrTextBox    *cmdhistory ;
	GlDynArray < std::string > *cmdhistorybuf ;
	KrTextWidget *cmdline ;
	std::string cmdline_bak ;
	GlDynArray < std::string > cmdlinebuf ;
	uint cmdlinebuf_pos ;
} ;

#endif

#endif
