#ifndef __DEFINITIONS_H
#define __DEFINITIONS_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#  if HAVE_LIBSDL_NET == 1
#    define __NETWORK_SUPPORT__
#  endif
#endif

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>
#include <stdlib.h>

#include <Kyra/kyra.h>

#ifndef __WIN32__
	#define TRUE true
	#define FALSE false
#endif

#define AUTO	-9999
#define RANDOM	-9998
#define NOTHING -9997 // needed by hid api to do nothing
#define FOREVER	-1
#define ONCE     0    // used to play music or sfx once ( 0 = no loop )

#include "utils.h"
#include "filecache.h"

#define GAME_TITLE "Gem Hunters"

#define CACHE_DIR "cache"

#define RC_DIR "~/.gemhun"

const int FRAMERATE = 50 ;
const float FRAMEDELAY = 1000 / (float) FRAMERATE ;

#define SDL_TIMER_EVENT ( SDL_NUMEVENTS - 1 )
const int TIMER_INTERVAL = (int) FRAMEDELAY ;

// Change this to a lower number, for example 32000 if you don't need this quality
#define AUDIO_RATE 44100
// 16-bit stereo
#define AUDIO_FORMAT MIX_DEFAULT_FORMAT
// How many audio channels to mix into output
#define AUDIO_CHANNELS 64
// Change this to a lower number if you want lower latency
#ifndef __WIN32__
	#define AUDIO_BUFFERS 1024 // linux is faster :)
#else
	#define AUDIO_BUFFERS 4096 // winxp sounds choppy if smaller :/
#endif

#endif
