#ifndef __FILECACHE_H
#define __FILECACHE_H

#include "definitions.h"

#include <malloc.h>

#define FILECACHE_SIZE 64

class FileCache
{
	public:
	void Init () ;
	
	int SearchForFilename ( char *filename ) ;
	int SearchForData ( void *data ) ;
	
	void *GetFromCache ( char *filename ) ;
	int  PutIntoCache ( char *filename, void *data ) ;
	int  IncreaseDependency ( int pos ) ;
	int  FreeFileFromCache ( char *filename ) ;
	int  FreeDataFromCache ( void *data ) ;
	
	void Reorganize () ;
	
	void DumpStatus () ;
	
	void Quit () ;
	
	// additional functions for kyra
	
	void *CachedLoad ( char *type, char *filename ) ;
	void FreeCachedData ( char *type, void *object ) ;
	
	private:
	struct cache_entry
	{
		char filename [ 2048 ] ;
		void *data ;
		int  ref_count ;
	} ;
	
	cache_entry cache [ FILECACHE_SIZE ] ;
} ;

#endif
