#ifndef __FPS_H
#define __FPS_H

#include "definitions.h"

// FPS counter:
// 0 = very old system
// 1 = old system
// 2 = new system
#define USE_FRAMERATE_VERSION 1

class FPS
{
	public:
	void Init () ;
	
	void Update () ;
	
	void DumpStatus () ;
	void PrintStatistics () ;
	
	float GetFramerate () ;
	float GetFramesLost () ;
	
	void DrawFPSText ( int fps ) ;
	void Draw () ;
	
	bool FpsReached () ;
	
	void SetSpeedToSlow () ;
	void SetSpeedToNormal () ;
	
	void Quit () ;
	
	private:
	KrEngine *engine ;
	
	Uint32 start_time ;

#if USE_FRAMERATE_VERSION == 0
	Uint32 LastTick ;
	Uint32 ThisTick ;
	Uint32 LastCheckTick ;
#endif
	float framerate ;
	float lost_frames ;

	KrResourceVault *fontVault ;
	KrFontResource *font ;
	KrTextBox *textBox ;
	
	// some kind of framerate modifier...
	int fps_throttle, fps_throttle_normal, fps_throttle_paused ;
} ;

#endif
