#ifndef __GAME_H
#define __GAME_H

#include "definitions.h"

#include "gamebg_pkg.h"
#include "gamepf.h"

// theme engine
#include "pax.h"

class Game
{
	public:
	void Init ( char *pkg_filename, char *left_level, char *right_level,
				int left_ai = 0, int right_ai = 0 ) ;
	
	void ProcessEvents ( SDL_Event event ) ;
	
	void Pause () ;
	void UnPause () ;
	
	void Draw () ;
	void AfterDraw () ;
	
	bool IsQuitting () ;
	bool IsDone () ;
	
	void Quit () ;
	
	private:
	void SetupGetReadySetGoText ( char *surface ) ;
	void ResetGetReadySetGoText ( char *surface ) ;
	void UpdateGetReadySetGoTextBig () ;
	void UpdateGetReadySetGoTextSmall ( char *surface ) ;
	void FreeGetReadySetGoText ( char *surface ) ;
	
	Pax *pax ;

	GameBG_Pkg background ;

	GamePF playfield_left ;
	GamePF playfield_right ;
	
	int GEM_COUNT ;
	char GEM_FIRST_COLOR, GEM_BLOCK ;
	
	KrResourceVault *Vault ;
	Sprite get_ready_text, set_text, go_text ;
	Sprite get_ready_text_left , set_text_left , go_text_left  ;
	Sprite get_ready_text_right, set_text_right, go_text_right ;
	int text_state, text_state_left, text_state_right ;
	int text_counter, text_counter_left, text_counter_right ;
	Audio_Sound go_sound ;
	
	bool new_game, playfield_left_new, playfield_right_new ;
	bool paused ;
	
	bool quit_state ;
} ;

#endif
