#ifndef __GAMEBG_PKG_H
#define __GAMEBG_PKG_H

#include "definitions.h"

#include "audio.h"

#include "sprite.h"

// we also need some rain
#include "rain.h"

// theme engine
#include "pax.h"

class GameBG_Pkg
{
	public:
	void Init ( Pax *new_pax ) ;

	void Draw () ;
	bool PlayfieldIsReady () ;
	void SetPlayfieldIsReady ( bool value ) ;
	
	void ToggleMusic () ;
	
	void Pause () ;
	void UnPause () ;
	
	bool GetIsQuitting () ;
	bool GetIsDone () ;
	
	void PrepareQuit () ;
	void Quit () ;
	
	private:
	void SetLayerAlpha ( KrImNode *layer, int new_alpha ) ;

	Pax *pax ;
	
	bool is_game_screen ;
	
	KrImNode *playfield_left ;
	KrImNode *playfield_right ;

	KrImNode *preview_field_left ;
	KrImNode *preview_field_right ;
	
	Sprite *background ;
	
	Sprite *field_layer_left ;
	Sprite *field_layer_right ;
	
	Sprite *preview_layer_left ;
	Sprite *preview_layer_right ;
	
	Audio_Music *bgmusic ;
	
	bool ready_for_playing ;
	
	bool paused ; // whether game is paused
	U8 pause_value ;
	bool music_paused ;
	bool music_off ; // whether user turned off the music

	bool quit ; // whether to quit
	bool quit_state ; // already done?
	bool quit_script_started ; // script - will be executed by the pax engine
} ;

#endif
