#ifndef __GAMESCREEN_H
#define __GAMESCREEN_H

#include "definitions.h"

#include "pax_list.h"

#include "title.h"
#include "game.h"
#ifdef __NETWORK_SUPPORT__
#include "networkscreen.h"
#endif

// we divide our game in screens
enum
{
	GS_NONE   , // nothing / program has just been started
	GS_TITLE  , // titlescreen ( lets get started ;) )
	GS_SCORE  , // highscores ( a simple table )
	GS_GAME   , // gamescreen ( the real game screen )
	GS_NETWORK,	// network screen ( start network games )
	GS_OPTIONS	// option screen ( here one can change everything )
} ;

class GameScreen
{
	public:
	void Init () ;
	
	void ProcessEvents ( SDL_Event event ) ;
	
	void Pause () ;
	void UnPause () ;
	
	void Draw () ;
	void AfterDraw () ;
	
	bool IsQuitting () ;
	bool IsDone () ;
	
	void Quit () ;
	
	private:
	// whether a screen is initialized
	bool initialized ;
	// our main titleloop
	Title titleloop ;
	// our main gameloop
	Game gameloop ;
#ifdef __NETWORK_SUPPORT__
	// our network screenloop
	NetworkScreen netloop ;
#endif
	
	char left_levelfname [ 1024 ], right_levelfname [ 1024 ] ;
	
	bool quit ;
	bool quit_state ;
	
	bool is_done ; // whether the screen is done or not
} ;

#endif
