#ifndef __JOYSTICK_H
#define __JOYSTICK_H

#include "definitions.h"

class Joystick
{
	public:
	void Init () ;
	
	void ResetToDefaultsLeft () ;
	void ResetToDefaultsRight () ;
	
	bool Left_up_pressed ( SDL_Event event ) ;
	bool Left_down_pressed ( SDL_Event event ) ;
	bool Left_left_pressed ( SDL_Event event ) ;
	bool Left_right_pressed ( SDL_Event event ) ;
	bool Left_fire_pressed ( SDL_Event event ) ;

	bool Left_up_released ( SDL_Event event ) ;
	bool Left_down_released ( SDL_Event event ) ;
	bool Left_left_released ( SDL_Event event ) ;
	bool Left_right_released ( SDL_Event event ) ;
	bool Left_fire_released ( SDL_Event event ) ;

	bool Right_up_pressed ( SDL_Event event ) ;
	bool Right_down_pressed ( SDL_Event event ) ;
	bool Right_left_pressed ( SDL_Event event ) ;
	bool Right_right_pressed ( SDL_Event event ) ;
	bool Right_fire_pressed ( SDL_Event event ) ;

	bool Right_up_released ( SDL_Event event ) ;
	bool Right_down_released ( SDL_Event event ) ;
	bool Right_left_released ( SDL_Event event ) ;
	bool Right_right_released ( SDL_Event event ) ;
	bool Right_fire_released ( SDL_Event event ) ;

	void Quit () ;

	private:
	enum
	{
		JOY_UP,
		JOY_DOWN,
		JOY_LEFT,
		JOY_RIGHT,
		JOY_FIRE,
		JOY_NUM,
		
		JOY_AXIS,
		JOY_BALL,
		JOY_HAT,
		JOY_BUTTON
	} ;
	
	typedef struct
	{
		Uint8 type ;
		Uint8 num ;
		Sint16 value ;
	} JoyMap ;
	
	void SetupDefaultMapping () ;

	int GetNumJoysticks () ;
	int GetIndex ( SDL_Joystick *joystick ) ;
	char *GetName ( SDL_Joystick *joystick ) ;
	int GetNumAxes ( SDL_Joystick *joystick ) ;
	int GetNumBalls ( SDL_Joystick *joystick ) ;
	int GetNumHats ( SDL_Joystick *joystick ) ;
	int GetNumButtons ( SDL_Joystick *joystick ) ;
	
	void Inspect ( SDL_Joystick *joystick ) ;
	
	int Test ( SDL_Joystick *joystick, JoyMap mapping_struct [ JOY_NUM ],
				Uint8 key, SDL_Event event ) ;
	
	JoyMap left_mapping [ JOY_NUM ] ;
	JoyMap right_mapping [ JOY_NUM ] ;
	JoyMap default_mapping [ JOY_NUM ] ;
	
	SDL_Joystick *left, *right ;
	
	int num_joysticks ;
} ;

#endif
