#ifndef __NCONSOLE_H
#define __NCONSOLE_H

#include "definitions.h"

#ifdef __NETWORK_SUPPORT__

#ifdef __NCURSES_SUPPORT__

class NConsole
{
	public:
	NConsole () ;
	
	void PushText ( std::string text ) ;
	void Printf ( const char *format, ... ) ;
	
	void PrintText ( uint x, uint y, char *text,
						int num_chars = AUTO, int color_pair = NOTHING ) ;
	
	void PrintHLine ( uint x, uint y, uint num_chars, uint color_pair ) ;
	void PrintVLine ( uint x, uint y, uint num_chars, uint color_pair ) ;
	
	void UpdateBuddyList ( GlDynArray < std::string > *buddy_list ) ;
	
	void Update () ;
	
	~NConsole () ;
	
	private:
	uint screenw, screenh ;
	GlDynArray < std::string > textbuffer ;
	GlDynArray < std::string > buddies ;
	
	char *cmdline ;
	char *cmdline_bak ;
	uint  cmdline_length ;
	uint  cmdline_pos ; // horizontal pos in commandline (cursor)
	uint  cmdline_vpos ; // offset for scrollbar
	GlDynArray < std::string > cmdhistory ;
	uint cmdhistory_pos ;
} ;

#endif

#endif

#endif
