#ifndef __NETWORKSCREEN_H
#define __NETWORKSCREEN_H

#include "definitions.h"

#ifdef __NETWORK_SUPPORT__

#include "gamebg_pkg.h"
#include "sprite.h"

// theme engine
#include "pax.h"

#include "mouse_cursor.h"

#include "console.h"

#include <dirent.h>

class NetworkScreen
{
	public:
	void Init () ;
	
	void ProcessEvents ( SDL_Event event ) ;
	
	void Pause () ;
	void UnPause () ;
	
	void Draw () ;
	void AfterDraw () ;
	
	bool IsQuitting () ;
	bool IsDone () ;
	
	void Quit () ;
	
	private:
	char *left_levelfname, *right_levelfname ;
	
	bool using_opengl ;	
	
	Pax *pax ;
	GameBG_Pkg background ;

	Audio_Sound activate_sound ;
	
	KrResourceVault *vault ;
	
	MouseCursor *mouse ;
	
	Sprite *bg_sprite ;

	Console *console ;
	Console *buddy_list ;
	
	KrPushButton *play_button ;

	bool paused ;

	bool quit ;
	bool quit_state ;
} ;

#endif

#endif
