#ifndef __PAX_LIST_H
#define __PAX_LIST_H

#include "definitions.h"

#include "gamebg_pkg.h"
#include "sprite.h"

// theme engine
#include "pax.h"

#include <dirent.h>

class PaxList
{
	public:
	enum
	{
		PLB_NONE,
		PLB_WHITE
	} ;
	
	struct pax_item
	{
		char            *pathname    ;
		char			*shortname   ;
		
		KrResourceVault *vault       ;
		char            *gfx_name    ;
		Sprite          *node        ;
		Sprite          *screenshot  ;
		Sprite          *border      ;
		
		char            *name        ;
		char            *author      ;
		char            *description ;
		
		void            *user_data   ;
	} ;
	
	GlDynArray < pax_item* > *list ;
	
	void Init ( void *user_data = NULL ) ;
	
	void ScanDirForPax ( char *current_path, void *user_data = NULL ) ;
	
	void AttachListToNode ( KrImNode *basenode = NULL,
							unsigned int border_type = PLB_NONE ) ;
	void DetachList () ;
	
	int FindPaxElement ( char *pkg_fname ) ;
	
	// emulate GLDynArray *pax_list
	unsigned int Count () ;
	pax_item *Item ( unsigned int n ) ;
	
	// draw an element ( -1 means all )
	void Draw ( int item = -1 ) ;
	
	// detach and free everything
	void Free () ;
	
	private:
	unsigned int border ;
	bool pax_list_attached, pax_list_created ;
	
	KrResourceVault *MiscVault ;
} ;

#endif
