#ifndef __RAIN_H
#define __RAIN_H

#include "definitions.h"

class Rain
{
	public:
	void Init ( KrImNode *new_basefield, char *rain_type = "rain" ) ;
	void SetAlpha ( int id, int new_alpha ) ;
	void UpdateAlpha ( int id ) ;
	void SetMaxDrops ( int new_max_drops ) ;
	void SetCreationArea ( int new_x, int new_y, int new_w, int new_h ) ;
	void SetLifeTime ( int new_life_time ) ;
	void SetSpeed ( int new_speed_x, int new_speed_y, 
					bool new_scheduled_waits = FALSE ) ;
	
	void AddDrop ( int id ) ;
	void DelDrop ( int id ) ;
	
	void Start () ;
	void Stop () ;
	
	void Draw () ;
	
	bool RainHasStopped () ;
	
	void Quit () ;
	
	private:
	int MAX_RAIN_DROPS ;
	
	KrEngine *engine ;
	bool using_opengl ;

	KrImNode *basefield ;
	int max_drops ;
	int dest_max_drops ;
	int dest_max_drops_counter ;
	int dest_max_drops_delay ;
	int old_max_drops ;
	
	int *cur_alpha ;
	int *dest_alpha ;
	
	// the area in which new drops will appear - default is SCREEN size!
	int area_x, area_y, area_w, area_h ;
	// how fast we go
	int speed_x, speed_y ;
	// if we wait some time before throwing in new drops
	bool scheduled_waits ;
	// how long in pixels a particle should live
	int life_time ;
	int *pos_in_life_time ;
	
	int drop_wait_counter ;
	int drop_wait_delay ;
	
	KrResourceVault *Vault ;
	KrSpriteResource *rainRes ;
	KrSprite **drop ;
	bool *drop_active ;

	bool rain_stopped ;
	
	Uint32 ThisTick, LastTick ;
} ;

#endif
