#ifndef __TITLE_H
#define __TITLE_H

#include "definitions.h"

#include "gamebg_pkg.h"
#include "sprite.h"

// theme engine
#include "pax.h"

#include <dirent.h>

class Title
{
	public:
	void Init ( char *new_left_levelfname, char *new_right_levelfname ) ;
	
	void ProcessEvents ( SDL_Event event ) ;
	
	void Pause () ;
	void UnPause () ;
	
	void Draw () ;
	void AfterDraw () ;
	
	bool IsQuitting () ;
	bool IsDone () ;
	
	void Quit () ;
	
	struct pax_item_addon
	{
		double c_pos ; // counter pos
		double c_max ; // max c_pos value
		double d_pos ; // delay pos
		double d_max ; // max d_pos value
		double scale_x ; // horizontal scaling
		double scale_y ; // vertical scaling
	} ;
	
	private:
	char *left_levelfname, *right_levelfname ;
	bool continue_last_game ;

	Audio_Sound activate_sound ;
	Sprite *arrow_left ;
	Sprite *arrow_right ;
	Sprite *arrow_up ;
	Sprite *arrow_down ;
	
	int menu_line ;
	int menu_line_max ;
	
	enum
	{
		ML_START_GAME,
		ML_START_TYPE,
		ML_NETWORK,
		ML_EDITOR,
		ML_OPTIONS,
		ML_QUIT,
		ML_COUNT
	} ;
	
	Sprite *dark_block ;
	Sprite *start_game_dummy ;
	Sprite *start_type_dummy ;
	Sprite *network_dummy ;
	Sprite *editor_dummy ;
	Sprite *options_dummy ;
	Sprite *quit_dummy ;
	
	KrResourceVault *MenuVault ;
	Sprite *new_game_text ;
	Sprite *continue_last_game_text ;
	Sprite *load_game_text ;
	Sprite *erase_game_text ;
	Sprite *network_text ;
	Sprite *level_editor_text ;
	Sprite *options_text ;
	Sprite *quit_text ;
	Sprite *nopax_text, *nopax_text_part1, *nopax_text_part2 ;
	Sprite *nopax_text_part3, *nopax_text_part4, *nopax_text_part5 ;
	
	int nopax_text_direction ;
	
	void EnablePaxElement ( int element ) ;
	void DisablePaxElement ( int element ) ;
	void DrawPaxList () ;
	void ShowPaxList () ;
	void HidePaxList () ;
	void QuitPaxList () ;
	
	int pax_list_offset ;
	int pax_list_old_offset ;
	int pax_list_cur_item ;
	int pax_list_last_item ;
	
	int game_type_cur_item, game_type_item_count, game_type_last_item ;
	
	bool using_opengl ;	
	
	Pax *pax ;
	
	GameBG_Pkg background ;
	
	Sprite *logo_gem, *logo_hunters ;

	KrResourceVault *MiscVault ;

	bool paused ;

	bool quit ;
	bool quit_state ;
} ;

#endif
