#ifndef __UTILS_H
#define __UTILS_H

#include <sys/stat.h>
#include <dirent.h>

#ifdef __WIN32__
#include <io.h>
#endif

#include "definitions.h"

#define ARRAY_SIZE(a) (sizeof(a) / sizeof(a[0]))

GlDynArray < std::string > BreakTextToMaxCols ( std::string text, uint max_cols ) ;

std::string CreateKey ( Uint32 seed = 0 ) ;

char *temp_file ( char *filename ) ;

void cleanup_temp_dir ( void ) ;

int min ( int a, int b ) ;
int max ( int a, int b ) ;
int clamp ( int value, int min, int max ) ;
void clamp ( int *value, int min, int max ) ;

bool compare_start_of_string ( char *haystack, char *needle ) ;

int hex_string_to_int ( char *string, int start = 0, int length = -1 ) ;

void create_config_dir () ;

#ifdef __WIN32__
char *index  ( char *s, int c ) ;
char *rindex ( char *s, int c ) ;
#endif

// myscandir - return number of items found in dir
int myscandir ( const char *dirname, GlDynArray < dirent > *namelist ) ;

bool isdir ( char *filename ) ;

char *dirname ( char *filepath ) ;
char *basename ( char *filepath ) ;

#endif
